<?php
// $Id: to_do.users.autocomplete.inc,v 1.1.2.1 2010/05/22 08:32:47 alexiswilke Exp $

/**
 * @file
 * Function used to auto-complete user assignments.
 */

function to_do_autocomplete_users($string = '') {
  // anything yet?
  if (!$string) {
    echo drupal_to_js(array());
    exit();
  }

  if (!user_access('to do list assignment')) {
    drupal_access_denied();
    return;
  }

  global $user;

  // Grab the first 10 users who can be assigned a To do list item
  $roles = _to_do_roles();

  // ignore self since we should not included him here
  $sql = "SELECT u.uid, u.name FROM {users} u, {users_roles} r"
    . " WHERE u.uid <> %d AND u.uid = r.uid AND r.rid IN (" . db_placeholders($roles, 'int') . ")"
      . " AND LOWER(u.name) LIKE LOWER('%s%%')";

  $result = db_query_range($sql, array_merge(array($user->uid), array_flip($roles), array($string)), 0, 10);

  $matches = array();
  while ($account = db_fetch_object($result)) {
    $matches[$account->name] = check_plain($account->name) . ' [uid:' . $account->uid . ']';
  }

  echo drupal_to_js($matches);
  exit();
}

// vim: ts=2 sw=2 et syntax=php
